/
githubmirror
/
strace
Обзор
Документация
Войти
/
githubmirror
/
strace
Код
Запросы
0
Пакеты
0
Релизы
0
Аналитика
Безопасность
master
tests/strace-k.test
142 строки
3 KB
Dmitry V. Levin
Update copyright headers
19 мар 2024, 15:00
19 мар 2024, 15:00
41a93df
Код
Авторство
О чём код?
#!/bin/sh # # Ensure that strace -k works. # # Copyright (c) 2014 Masatake YAMATO <yamato@redhat.com> # Copyright (c) 2014-2016 Dmitry V. Levin <ldv@strace.io> # Copyright (c) 2014-2024 The strace developers. # All rights reserved. # # SPDX-License-Identifier: GPL-2.0-or-later . "${srcdir=.}/init.sh" : "${ATTACH_MODE=0}" : "${KOPT_SHORT=-k}" : "${KOPT_LONG=--stack-trace}" : "${KOPT_EXTRA=}" # strace -k is implemented using /proc/$pid/maps [ -f /proc/self/maps ] || framework_skip_ '/proc/self/maps is not available' check_prog grep check_prog readlink check_prog sed check_prog tr path_to_sed="$(command -v sed)" if [ -x "$path_to_sed" ] && path_to_sed="$(readlink -ev -- "$path_to_sed")"; then "$path_to_sed" -n 's/^[^/]\+[[:space:]]\(\/.*\)$/\1/p' /proc/self/maps | grep -F -x -e "$path_to_sed" > /dev/null || { cat >&2 /proc/self/maps framework_skip_ '/proc/self/maps is invalid' } fi run_prog "${test_prog=../stack-fcall}" if [ "x${ATTACH_MODE}" = "x1" ]; then ../set_ptracer_any "${test_prog}" >> "$EXP" & tracee_pid=$! while ! [ -s "$EXP" ]; do kill -0 "$tracee_pid" 2> /dev/null || fail_ 'set_ptracer_any failed' done run_strace --trace=chdir ${KOPT_LONG} ${KOPT_EXTRA} --attach="$tracee_pid" else run_strace -e chdir ${KOPT_SHORT} ${KOPT_EXTRA} $args fi expected="$srcdir/$NAME.expected" awk_script_common=' /^[^ ]/ { if (out != "") print out syscall = gensub(/^([[:alnum:]_]+)\(.*/, "\\1", 1) signal = gensub(/^--- ([A-Z]+) .*/, "\\1", 1) if (syscall != $0) { out = syscall stop = 0 } else if (signal != $0) { out = signal stop = 0 } else { out = "" } } /^ > too many stack frames/ { out = out " _too_many_stack_frames_" stop = 1 } ' awk_script_symbol=' /^ >[^(]+\(([^+]+)\+0x[a-f0-9]+\) / && !stop { sym = gensub(/^ >[^(]+\(([^+]+)\+0x[a-f0-9]+\) .*$/, "\\1", 1) out = out " " sym if (sym == "main") stop = 1 } ' awk_script_source=' /^ >[^(]+\(([^+]+)\+0x[a-f0-9]+\) \[0x[a-f0-9]+\] ([^:]+):([0-9]+)$/ && !stop { sym = gensub(/^ >[^(]+\(([^+]+)\+0x[a-f0-9]+\) .*$/, "\\1", 1) if (sym == "main" || sym ~ /f[0-9]/) { file = gensub(/^ >[^(]+\(([^+]+)\+0x[a-f0-9]+\) \[0x[a-f0-9]+\] ([^:]+):([0-9]+)$/, "\\2", 1) line = gensub(/^ >[^(]+\(([^+]+)\+0x[a-f0-9]+\) \[0x[a-f0-9]+\] ([^:]+):([0-9]+)$/, "\\3", 1) sub(".*/", "", file) out = out " " sym "<" file ":" line ">" if (sym == "main") stop = 1 } } ' if [ "${KOPT_LONG}" = "--stack-trace" ]; then awk_script="${awk_script_common}${awk_script_symbol}" else awk_script="${awk_script_common}${awk_script_source}" fi awk "${awk_script}" "$LOG" > "$OUT" LC_ALL=C grep -E -x -f "$expected" < "$OUT" > /dev/null || { cat >&2 <<__EOF__ Failed pattern of expected output: $(cat "$expected") Actual output: $(cat "$OUT") __EOF__ pattern= case "$STRACE_ARCH" in aarch64|i386|ppc*|s390*|sparc*|x32|x86*) # These architectures are supported by elfutils libdw, # see grep '\<HOOK\>.*\<abi_cfi\>' elfutils/backends ;; arm) pattern='No DWARF information found' # This is also supported by elfutils libdw # but the latter needs debuginfo for unwinding. ;; *) pattern='Unwinding not supported for this architecture' ;; esac if [ -n "$pattern" ] && LC_ALL=C grep -x " > $pattern" < "$LOG" > /dev/null; then cat < "$LOG" >&2 skip_ "stack tracing is not fully supported on $STRACE_ARCH yet" fi dump_log_and_fail_with "$STRACE $args output mismatch" }